这部分内容我不光会推荐书籍，还会顺便推荐一些我觉得不错的教学视频&Project。

## 算法

### 入门

先来看三本入门书籍，这三本入门书籍中的任何一本拿来作为入门学习都非常好。

- [《我的第一本算法书》](https://book.douban.com/subject/30357170/) 
- [《算法图解》](https://book.douban.com/subject/26979890/)
- [《啊哈!算法》](https://book.douban.com/subject/25894685/)

![](https://guide-blog-images.oss-cn-shenzhen.aliyuncs.com/java-guide-blog/image-20210327104418851.png)

我个人比较倾向于 **[《我的第一本算法书》](https://book.douban.com/subject/30357170/)** 这本书籍，虽然它相比于其他两本书集它的豆瓣评分略低一点。我觉得它的配图以及讲解是这三本书中最优秀，唯一比较明显的问题就是没有代码示例。但是，我觉得这不影响它是一本好的算法书籍。因为本身下面这三本入门书籍的目的就不是通过代码来让你的算法有多厉害，只是作为一本很好的入门书籍让你进入算法学习的大门。

### 经典

![](https://guide-blog-images.oss-cn-shenzhen.aliyuncs.com/java-guide-blog/s29107491.jpg)

**《算法》**

我在大二的时候被我们的一个老师强烈安利过！自己也在当时购买了一本放在宿舍，到离开大学的时候自己大概看了一半多一点。因为内容实在太多了！另外，这本书还提供了详细的 Java 代码，非常适合学习 Java 的朋友来看，可以说是 Java 程序员的必备书籍之一了。

> **下面这些书籍都是经典中的经典，但是阅读起来难度也比较大，不做太多阐述，神书就完事了！**

![](https://guide-blog-images.oss-cn-shenzhen.aliyuncs.com/java-guide-blog/s4687321.jpg)

**[《编程珠玑》](https://book.douban.com/subject/3227098/)**

经典名著，ACM 冠军、亚军这种算法巨佬都强烈推荐的一本书籍。这本书的作者也非常厉害，Java 之父 James Gosling 就是他的学生。

很多人都说这本书不是教你具体的算法，而是教你一种编程的思考方式。这种思考方式不仅仅在编程领域适用，在其他同样适用。

![](https://img-blog.csdnimg.cn/20210327105649620.png)

**[《算法设计手册》](https://book.douban.com/subject/4048566/)**

这是一本被Github上的爆火的计算机自学项目 [Teach Yourself Computer Science](https://link.zhihu.com/?target=https%3A//teachyourselfcs.com/) 强烈推荐的一本算法书籍。

类似的神书还有 [《算法导论》](https://book.douban.com/subject/20432061/)、[《计算机程序设计艺术（第1卷）》](https://book.douban.com/subject/1130500/) 。

![](https://img-blog.csdnimg.cn/20210327105804641.png)

![](https://img-blog.csdnimg.cn/20210327105858764.png)

### 面试

![](https://img-blog.csdnimg.cn/20210327110700786.png)

**[《剑指Offer》](https://book.douban.com/subject/6966465/)**

这本面试宝典上面涵盖了很多经典的算法面试题，如果你要准备大厂面试的话一定不要错过这本书。

《剑指 Offer》 对应的算法编程题部分的开源项目解析：[CodingInterviews](https://link.zhihu.com/?target=https%3A//github.com/gatieme/CodingInterviews) 。

![](https://img-blog.csdnimg.cn/20210327110712728.png)

**[《程序员代码面试指南（第2版）》](https://book.douban.com/subject/30422021/)**

题目相比于《剑指 offer》 来说要难很多，题目涵盖面相比于《剑指 offer》也更加全面。全书一共有将近 300 道真实出现过的经典代码面试题。

## 操作系统

如果你要系统地学习操作系统的话，最硬核最权威的书籍是 **《操作系统导论》** 。你可以再配套一个 **《深入理解计算机系统》** 加深你对计算机系统本质的认识，美滋滋！

![](https://cdn.jsdelivr.net/gh/javaguide-tech/blog-images/2020-10-12/image-20201012191645919.png)

如果你比较喜欢动手，对于理论知识比较抵触的话，我推荐你看看《30 天自制操作系统》，这本书会手把手教你编写一个操作系统。

![](https://cdn.jsdelivr.net/gh/javaguide-tech/blog-images/2020-10-12/s11138117.jpg)

如果你比较喜欢看视频的话，我建议你可以看看北京交通大学的慕课[《操作系统》](https://www.icourse163.org/course/NJTU-1003245001)。

![](https://cdn.jsdelivr.net/gh/javaguide-tech/blog-images-6@main/12-04-1/image-20201204131429567.png)

这个视频课程基本把操作系统的体系结构、设计机理及实现方法和技术相关重要的知识点介绍的差不多了。

还有下面这个国外的课程 [《深入理解计算机系统 》](https://www.bilibili.com/video/av31289365?from=search&seid=16298868573410423104) 也很不错。

![](https://cdn.jsdelivr.net/gh/javaguide-tech/blog-images-6@main/12-04-1/image-20201204140653318.png)

## 计算机网络

关于这门课，首先强烈推荐参考书是**机械工业出版社的《计算机网络——自顶向下方法》**。该书目录清晰，按照 TCP/IP 五层模型逐层讲解，对每层涉及的技术都展开了详细讨论，基本上高校里开设的课程的教学大纲就是这本书的目录了。

![](https://cdn.jsdelivr.net/gh/javaguide-tech/blog-images/2020-10/%E8%AE%A1%E7%AE%97%E6%9C%BA%E7%BD%91%E7%BB%9C.jpg)

如果你觉得上面这本书看着比较枯燥的话，我强烈推荐+安利你看看下面这两本非常有趣的网络相关的书籍：

- [《图解 HTTP》](https://book.douban.com/subject/25863515/ "《图解 HTTP》") ： 讲漫画一样的讲 HTTP，很有意思，不会觉得枯燥，大概也涵盖也 HTTP 常见的知识点。因为篇幅问题，内容可能不太全面。不过，如果不是专门做网络方向研究的小伙伴想研究 HTTP 相关知识的话，读这本书的话应该来说就差不多了。
- [《网络是怎样连接的》](https://book.douban.com/subject/26941639/ "《网络是怎样连接的》") ：从在浏览器中输入网址开始，一路追踪了到显示出网页内容为止的整个过程，以图配文，讲解了网络的全貌，并重点介绍了实际的网络设备和软件是如何工作的。

![](https://cdn.jsdelivr.net/gh/javaguide-tech/blog-images/2020-10/image-20201011215144139.png)

除了理论知识之外，学习计算机网络非常重要的一点就是：“**动手实践**”。这点和我们编程差不多。

Github 上就有一些名校的计算机网络试验/Project：

- [哈工大计算机网络实验](https://github.com/rccoder/HIT-Computer-Network)
- [《计算机网络－自顶向下方法(原书第6版)》编程作业，Wireshark实验文档的翻译和解答。](https://github.com/moranzcw/Computer-Networking-A-Top-Down-Approach-NOTES)
- [计算机网络的期末Project，用Python编写的聊天室](https://github.com/KevinWang15/network-pj-chatroom)
- [CMU的计算机网络课程](https://computer-networks.github.io/sp19/lectures.html)

我知道，还有很多小伙伴可能比较喜欢边看视频边学习。所以，我这里再推荐几个顶好的计算机网络视频讲解。

**1.[哈工大的计算机网络课程](http://www.icourse163.org/course/HIT-154005)** ：国家精品课程，截止目前已经开了10次课了。大家对这门课的评价都非常高！所以，非常推荐大家看一下！

![](https://cdn.jsdelivr.net/gh/javaguide-tech/blog-images-6@main/12-15-1/image-20201218141241911.png)

**2.[王道考研的计算机网络](https://www.bilibili.com/video/BV19E411D78Q?from=search&seid=17198507506906312317)** ：非常适合CS专业考研的小朋友！这个视频目前在哔哩哔哩上已经有1.6w+的点赞。

![](https://cdn.jsdelivr.net/gh/javaguide-tech/blog-images-6@main/12-18-1/image-20201218141652837.png)

除了上面推荐的书籍和视频之外，再推荐两篇计算机网络总结的文章：

- [计算机网络常见面试题](https://snailclimb.gitee.io/javaguide/#/docs/network/%E8%AE%A1%E7%AE%97%E6%9C%BA%E7%BD%91%E7%BB%9C)
- [计算机网络基础知识总结](https://snailclimb.gitee.io/javaguide/#/docs/network/计算机网络知识总结)

最后再补充一个：[浙江大学的计算机网络课程资料、教材和试卷](https://github.com/QSCTech/zju-icicles/tree/master/%E8%AE%A1%E7%AE%97%E6%9C%BA%E7%BD%91%E7%BB%9C%E5%9F%BA%E7%A1%80) 。需要的小伙伴请查收！

